                   // Copyright (c) 2011-2014 Partner400                                    
                   // All rights reserved.                                                        
                   //                                                                             
                   // Redistribution and use in source and binary forms, with or without          
                   // modification, are permitted provided that the following conditions          
                   // are met:                                                                    
                   // 1. Redistributions of source code must retain the above copyright           
                   //    notice, this list of conditions and the following disclaimer.            
                   // 2. Redistributions in binary form must reproduce the above copyright        
                   //    notice, this list of conditions and the following disclaimer in the
                   //    documentation and/or other materials provided with the distribution.     
                   //                                                                             
                   // THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ''AS IS'' AND      
                   // ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE       
                   // IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE  
                   // ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE     
                   // FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL  
                   // DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS     
                   // OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)       
                   // HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT  
                   // LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY   
                   // OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF      
                   // SUCH DAMAGE.                                                                
                   //                                                                             

000100141130       Ctl-Opt DftActGrp(*No) Option(*SrcStmt: *NoDebugIO);
000101141130
000107141130       // Standard IBM supplied Open Access definitions
000108141130      /Copy QRNOPENACC
000109141130
000110141130       // Copy constants for RPG status codes - write your own or use mine
000111141130       //   email me at Contact at Partner400 dot com for a copy
000112141201      /Copy ExtraSrc,StatusCdsF
000113141130
000114141201       // Standard IBM supplied IFS prototypes
000115141201      /copy qsysinc/qrpglesrc,ifs
000116141201
000117141130       // Protos for program and local procedures. In V7+ these can be
000118141130       //   removed if the actual subprocs are in this same source file
000119141130
000120141201       Dcl-Pr OpenFile   Like(stateInfo.IFShandle) End-Pr;
000121141130
000122141201       Dcl-Pr CloseFile;
000123141201         handle  Like(stateInfo.IFShandle);
000124141201       End-Pr;
000125141201
000126141130       // Change PR to use ExtProc etc. if required. Can be omitted in V7+
000127141201(A)    Dcl-Pr IFSHandlerV2F ExtPgm('IFSHANDL2F');
000128141130         info likeds(QrnOpenAccess_T);
000129141130       End-Pr;
000130141130
000131141130       // The following is the definition of the additional user parameter.
000132141130       //   Add any fields etc here as required. Good idea to have the actual
000133141130       //   definitions in a /Copy so the user program can use the same ones.
000134141130
000135141201       Dcl-Ds userData Based(info.userArea) Qualified;
000136141201(B)   /Copy ExtraSrc,IFSPARMDTF
000137141130       End-Ds;
000138141130
000139141130
000140141130       // Use either the input and/or output buffer definitions or
000141141130       // the Names/Values structure as required
000142141130       // *Note: Delete the ones you don't need
000143141130
000144141130       Dcl-Ds nvInput      LikeDS(QrnNamesValues_T)
000145141130                           based(info.NamesValues);
000146141130
000147141130       // For Name/Value you'll also need this field to map the values
000148141130       //   Set the pointer in the Select logic for the I/O ops that need it
000149141130       Dcl-S value         Char(32470) Based(pvalue);
000150141130
000151141130       // State information - automatically mapped via info.stateInfo pointer
000152141201(C)    Dcl-Ds stateInfo  Based(info.stateInfo) Qualified;
000153141130         // This is where you define any fields you need to preserve
000154141130         //   for a specific file
000155141201         IFShandle  Int(10);
000156141201      /Copy ExtraSrc,IFSPARMDTF
000157141130       End-Ds;
000158141130
000159141130       // Procedure interface for program - only a single parameter
000160141201(D)    Dcl-Pi IFSHandlerV2F;
000161141130         info likeds(QrnOpenAccess_T);
000162141130       End-Pi;
000163141130
000164141130       // Main logic begins by determining operation requested
000165141130
000166141130       Select;
000167141201
000168141201(E)      When info.rpgOperation = QrnOperation_WRITE;
000169141201
000170141201            // Write error is unlikely but signal it if it occurs
000171141201            If ( writeFile(stateInfo.IFShandle) < 0 );
000172141201               dsply ('Error on IFS file write');
000173141201               info.rpgStatus = errIO;
000174141201            EndIf;
000175141201
000176141201         When (info.rpgOperation = QrnOperation_OPEN);
000179141201           OpenFile();
000180141201         When (info.rpgOperation = QrnOperation_CLOSE);
000181141201         CloseFile(stateInfo.IFShandle);
000182141130
000183141130         // Processes any op-codes the handler is not designed for here.
000184141130         // You must report the error to RPG and should log something.
000185141130         // A real production handler would also report the actual
000186141130         //   operation that was being attempted.
000187141130       Other;
000188141130         Dsply ('Unsupported I/O op. ' + %Char(info.rpgOperation) +
000189141130         ' on file ' + info.externalFile.name );
000190141130         info.rpgStatus = errIO;
000191141130       EndSl;
000192141130
000193141130       Return;
000194141130
000195141130      // Basic outline logic for Open function
000196141130       Dcl-Proc OpenFile;
000197141201       Dcl-Pi  *N   Like(stateInfo.IFShandle) End-Pi;
000198141130
000199141201       // Specify that we want to use Name/Value information
000200141201       // *Note: Remove this line for a buffer handler application
000201141201       info.useNamesValues = *On;
000202141201
000203141130       // If no state info area yet allocate now and initialize
000204141130       If info.stateInfo = *null;
000205141130         info.stateInfo = %Alloc( %Size(stateInfo));
000206141130         Clear stateInfo;
000207141130       EndIf;
000208141130
000209141130       // Check if user parm was supplied and set defaults if needed
000210141130       // Good idea to store parm values in state info area otherwise if
000211141130       //   caller changes the values it could really mess you up
000212141201(F)    If info.userArea = *Null;
000213141201         stateinfo.headerRow = 'Y';  // Default to producing header row
000214141201         stateinfo.separator = ',';  //   Comma for separator
000215141201         stateinfo.IFSfileName = '/Partner400/' +
000216141201                                 %TrimR(%Subst(info.externalFile: 1 : 10)) +
000217141201                                 '.csv';  // Default from external file name
000218141201       Else;  // Copy supplied definitions into state info area
000219141201         Eval-Corr stateinfo = userData;
000220141201       EndIf;
000221141201
000222141201       stateInfo.IFShandle = open( stateinfo.IFSfileName
000223141201                           :  O_CREAT + O_WRONLY + O_CCSID + O_TRUNC
000224141201                           + O_TEXTDATA + O_TEXT_CREAT
000225141201                           : S_IRUSR + S_IWUSR + S_IRGRP + S_IROTH
000226141201                           : 819
000227141201                           : 0 );
000228141201
000229141201       Return stateInfo.IFShandle;
000230141201
000231141130       End-Proc OpenFile;
000232141130
000233141130      // Basic outline for file Close operation
000234141130       Dcl-Proc CloseFile;
000235141201       Dcl-Pi  *N;
000236141201         handle  Like(stateInfo.IFShandle);
000238141201       End-Pi;
000239141130
000240141201       Dcl-S rc  INt(10);
000241141201
000242141201       rc = close(handle); // Close IFS file - rc is just for debugging
000243141201
000244141130       // Release storage holding state information
000245141130       //   and set pointer to null. That way we can't ever reference
000246141130       //   it by mistake.
000247141130
000248141130       Dealloc info.stateInfo;
000249141130       info.stateInfo = *null;
000250141130       info.rpgStatus = stsOK;
000251141130
000252141130       Return;
000253141130
000254141130       End-Proc CloseFile;
000255141130
000256141201
000257141201       Dcl-Proc writeFile;
000258141201       Dcl-Pi *N like(stateInfo.IFShandle);
000259141201         handle like(stateInfo.IFShandle) value;
000260141201       End-Pi;
000261141201
000262141201       // Buffer length is arbitrary but 32K should be big enough
000263141201       Dcl-S buffer  Varchar(32740) Inz;
000264141201       Dcl-S header  Varchar(32740) Inz;
000265141201       Dcl-S i       Int(5);
000266141201       Dcl-S reply   Int(10);
000267141201       Dcl-C quote   '"';
000268141201       Dcl-C CRLF    x'0d25';
000269141201
000270141201
000271141201       // Process all fields in record
000272141201       For i = 1 to nvInput.num;
000273141201(G)      If ( stateInfo.headerRow = 'Y' );
000274141201           header += %Trimr(nvInput.field(i).externalName); // Use field name as header
000275141201           If i <> nvInput.num; // Add separator after every field except the last
000276141201             header += stateInfo.separator;
000277141201           Else;                // Last field so write out header
000278141201             header += CRLF; // Add record termination
000279141201             reply = write ( handle: %Addr(header: *Data): %Len(header) );
000280141201             stateInfo.headerRow = 'N'; // And turn off header output
000281141201           EndIf;
000282141201         EndIf;
000283141201
000284141201         pvalue = nvInput.field(i).value; // set up to access data
000285141201
000286141201         If ( nvInput.field(i).dataType = QrnDatatype_Alpha )
000287141201         Or ( nvInput.field(i).dataType = QrnDatatype_AlphaVarying);
000288141201           buffer += quote
000289141201                   + %trimR( %subst( value: 1: nvInput.field(i).valueLenBytes ))
000290141201                   + quote;
000291141201
000292141201         ElseIf ( nvInput.field(i).dataType = QrnDatatype_Decimal );
000293141201           buffer += %subst(value: 1: nvInput.field(i).valueLenBytes);
000294141201
000295141201         ElseIf ( nvInput.field(i).dataType = QrnDatatype_Date );
000296141201           buffer += %subst(value: 1: nvInput.field(i).valueLenBytes);
000297141201
000298141201         EndIf;
000299141201
000300141201         If i <> nvInput.num; // Add comma after every field except the last
000301141201           buffer += stateInfo.separator;
000302141201         EndIf;
000303141201
000304141201       EndFor;
000305141201
000306141201       buffer += CRLF; // Add record termination
000307141201
000308141201       // reply will contain the length of data written or -1 in case of error
000309141201       reply = write ( handle: %Addr(buffer:*Data): %Len(buffer) );
000310141201
000311141201       Return reply;
000312141201
000313141201       End-Proc writeFile;
000314141201
