                   // Copyright (c) 2011-2014 Partner400                                    
                   // All rights reserved.                                                        
                   //                                                                             
                   // Redistribution and use in source and binary forms, with or without          
                   // modification, are permitted provided that the following conditions          
                   // are met:                                                                    
                   // 1. Redistributions of source code must retain the above copyright           
                   //    notice, this list of conditions and the following disclaimer.            
                   // 2. Redistributions in binary form must reproduce the above copyright        
                   //    notice, this list of conditions and the following disclaimer in the
                   //    documentation and/or other materials provided with the distribution.     
                   //                                                                             
                   // THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ''AS IS'' AND      
                   // ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE       
                   // IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE  
                   // ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE     
                   // FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL  
                   // DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS     
                   // OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)       
                   // HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT  
                   // LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY   
                   // OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF      
                   // SUCH DAMAGE.                                                                
                   //                                                                             

000100141130     H DftActGrp(*No) Option(*SrcStmt: *NoDebugIO)
000101141130
000106141130       // Standard IBM supplied Open Access definitions
000107141130      /Copy QRNOPENACC
000108141130
000109141130       // Copy constants for RPG status codes - write your own or use mine
000110141130       //   email me at Contact at Partner400 dot com for a copy
000111141130      /Copy StatusCds
000112141130
000113141130       // Protos for program and local procedures - not needed V7+
000114141130     D OpenFile        Pr
000115141130
000116141130     D CloseFile       Pr
000117141130
000118141130       // Change to PR to use ExtProc etc. if required
000119141130     D HandlerName     Pr                  ExtPgm('XXXXXXXXXX')
000120141130     D   info                              likeds(QrnOpenAccess_T)
000121141130
000122141130       // The following is the definition of the additional user parameter.
000123141130       //   Add any fields etc here as required. Good idea to have the actual
000124141201       //   definitions in a /Copy so the user program can use the same ones.
000125141201     D userData        ds                  Based(info.userArea) Qualified
000126141130
000127141130       // Use either the input and/or output buffer definitions or
000128141130       // the Names/Values structure as required
000129141130
000130141130     D inputBuffer     s          64512a   Based(info.inputBuffer)
000131141130     D outputBuffer    s          64512a   Based(info.outputBuffer)
000132141130
000133141130     D nvInput         ds                  likeds(QrnNamesValues_T)
000134141130     D                                     based(info.NamesValues)
000135141130
000136141130       // For Name/Value you'll also need this field to map the values
000137141130       //   Set the pointer in the Select logic for the I/O ops that need it       //
000138141130     D value           s          32470a   Based(pvalue)
000139141130
000140141130       // State info - automatically mapped via info.stateInfo pointer
000141141130     D stateInfo       DS                  Based(info.stateInfo) Qualified
000142141130       // This is where you define any fields you need to preserve
000143141130       //   for a specific file
000144141130
000145141130       // Procedure interface for program - only a single parameter
000146141130     D HandlerName     PI
000147141130     D   info                              likeds(QrnOpenAccess_T)
000148141130
000149141130       Select;
000150141130
000151141130       // This is where you add any WHEN clauses for all required
000152141130       // operations such as READ, CHAIN, SETLL, etc.
000153141130       // Code is already in place for Open and close operations
000154141130
000155141130         When (info.rpgOperation = QrnOperation_OPEN);
000156141130           OpenFile();
000157141130         When (info.rpgOperation = QrnOperation_CLOSE);
000158141130           CloseFile();
000159141130
000160141130       // This section, processes op-codes the handler is not designed for.
000161141130       // You must report the error to RPG and should log something.
000162141130       // A real production handler would also report the actual
000163141130       //   operation that was being attempted.
000164141130         Other;
000165141130           Dsply ('Unsupported I/O op. ' + %Char(info.rpgOperation)
000166141130                + ' on file ' + info.externalFile.name );
000167141130           info.rpgStatus = errIO;
000168141130       EndSl;
000169141130
000170141130       Return;
000171141130
000172141130       // Basic outline logic for Open function
000173141130     P OpenFile        B
000174141130     D                 PI
000175141201
000176141201       // Specify that we want to use Name/Value information
000177141201       // *Note: Remove this line for a buffer handler application
000178141201       info.useNamesValues = *On;
000179141201
000180141130       // If no state info area yet allocate now and initialize
000181141130       If info.stateInfo = *null;
000182141130         info.stateInfo = %Alloc( %Size(stateInfo));
000183141130         Clear stateInfo;
000184141130       EndIf;
000185141130
000186141130       // Check if user parm was supplied and any set defaults if needed
000187141130       // Store parm values in state info area otherwise if caller
000188141130       //   changes the values it could really mess you up
000189141130       If info.userArea = *Null;
000190141130        // Add logic to set any default values required by handler
000191141130       Else;
000192141130        // Copy user supplied data into state info area to preserve
000193141130       EndIf;
000194141130
000195141130       Return;
000196141130
000197141130     P OpenFile        E
000198141130       // Basic outline for file Close operation
000199141130     P CloseFile       B
000200141130     D                 PI
000201141130
000202141130       // Release storage holding state information
000203141130       //   and set pointer to null.
000204141130       // That way we can't ever reference it by mistake.
000205141130
000206141130       Dealloc info.stateInfo;
000207141130       info.stateInfo = *null;
000208141130       info.rpgStatus = stsOK;
000209141130
000210141130       Return;
000211141130
000212141130     P CloseFile       E
000213141130
