                   // Copyright (c) 2011-2014 Partner400                                    
                   // All rights reserved.                                                        
                   //                                                                             
                   // Redistribution and use in source and binary forms, with or without          
                   // modification, are permitted provided that the following conditions          
                   // are met:                                                                    
                   // 1. Redistributions of source code must retain the above copyright           
                   //    notice, this list of conditions and the following disclaimer.            
                   // 2. Redistributions in binary form must reproduce the above copyright        
                   //    notice, this list of conditions and the following disclaimer in the
                   //    documentation and/or other materials provided with the distribution.     
                   //                                                                             
                   // THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ''AS IS'' AND      
                   // ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE       
                   // IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE  
                   // ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE     
                   // FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL  
                   // DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS     
                   // OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)       
                   // HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT  
                   // LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY   
                   // OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF      
                   // SUCH DAMAGE.                                                                
                   //                                                                             

000100141130       Ctl-Opt DftActGrp(*No) Option(*SrcStmt: *NoDebugIO);
000101141130
000107141130       // Standard IBM supplied Open Access definitions
000108141130      /Copy QRNOPENACC
000109141130
000110141130       // Copy constants for RPG status codes - write your own or use mine
000111141130       //   email me at Contact at Partner400 dot com for a copy
000112141130      /Copy StatusCdsF
000113141130
000114141130       // Protos for program and local procedures. In V7+ these can be
000115141130       //   removed if the actual subprocs are in this same source file
000116141130
000117141130       Dcl-Pr OpenFile   End-Pr;
000118141130
000119141130       Dcl-Pr CloseFile  End-Pr;
000120141130
000121141130       // Change PR to use ExtProc etc. if required. Can be omitted in V7+
000122141130       Dcl-Pr HandlerName ExtPgm('XXXXXXXXXX');
000123141130         info likeds(QrnOpenAccess_T);
000124141130       End-Pr;
000125141130
000126141130       // The following is the definition of the additional user parameter.
000127141130       //   Add any fields etc here as required. Good idea to have the actual
000128141130       //   definitions in a /Copy so the user program can use the same ones.
000129141130
000130141201       Dcl-Ds userData Based(info.userArea) Qualified;
000131141130          // Add any fields etc here as required.
000132141130       End-Ds;
000133141130
000134141130
000135141130       // Use either the input and/or output buffer definitions or
000136141130       // the Names/Values structure as required
000137141130       // *Note: Delete the ones you don't need
000138141130
000139141130       Dcl-S inputBuffer   Char(64512) Based(info.inputBuffer);
000140141130       Dcl-S outputBuffer  Char(64512) Based(info.outputBuffer);
000141141130
000142141130       Dcl-Ds nvInput      LikeDS(QrnNamesValues_T)
000143141130                           based(info.NamesValues);
000144141130
000145141130       // For Name/Value you'll also need this field to map the values
000146141130       //   Set the pointer in the Select logic for the I/O ops that need it
000147141130       Dcl-S value         Char(32470) Based(pvalue);
000148141130
000149141130       // State information - automatically mapped via info.stateInfo pointer
000150141130       Dcl-Ds stateInfo  Based(info.stateInfo) Qualified;
000151141130         // This is where you define any fields you need to preserve
000152141130         //   for a specific file
000153141130       End-Ds;
000154141130
000155141130       // Procedure interface for program - only a single parameter
000156141130       Dcl-Pi HandlerName;
000157141130         info likeds(QrnOpenAccess_T);
000158141130       End-Pi;
000159141130
000160141130       // Main logic begins by determining operation requested
000161141130
000162141130       Select;
000163141130
000164141130         // This is where you add WHEN clauses for all required
000165141130         // operations such as READ, CHAIN, SETLL, etc.
000166141130         // Basic code is already in place for Open and close operations
000167141130
000168141130       When (info.rpgOperation = QrnOperation_OPEN);
000169141130         OpenFile();
000170141130       When (info.rpgOperation = QrnOperation_CLOSE);
000171141130         CloseFile();
000172141130
000173141130         // Processes any op-codes the handler is not designed for here.
000174141130         // You must report the error to RPG and should log something.
000175141130         // A real production handler would also report the actual
000176141130         //   operation that was being attempted.
000177141130       Other;
000178141130         Dsply ('Unsupported I/O op. ' + %Char(info.rpgOperation) +
000179141130         ' on file ' + info.externalFile.name );
000180141130         info.rpgStatus = errIO;
000181141130       EndSl;
000182141130
000183141130       Return;
000184141130
000185141130      // Basic outline logic for Open function
000186141130       Dcl-Proc OpenFile;
000187141130       Dcl-Pi  *N   End-Pi;
000188141130
000189141201       // Specify that we want to use Name/Value information
000190141201       // *Note: Remove this line for a buffer handler application
000191141201       info.useNamesValues = *On;
000192141201
000193141130       // If no state info area yet allocate now and initialize
000194141130       If info.stateInfo = *null;
000195141130         info.stateInfo = %Alloc( %Size(stateInfo));
000196141130         Clear stateInfo;
000197141130       EndIf;
000198141130
000199141130       // Check if user parm was supplied and set defaults if needed
000200141130       // Good idea to store parm values in state info area otherwise if
000201141130       //   caller changes the values it could really mess you up
000202141130       If info.userArea = *Null;
000203141130         // Add logic to set any default values required by handler
000204141130       Else;
000205141130         // Copy user supplied data into state area to preserve
000206141130       EndIf;
000207141130
000208141130       Return;
000209141130
000210141130       End-Proc OpenFile;
000211141130
000212141130      // Basic outline for file Close operation
000213141130       Dcl-Proc CloseFile;
000214141130       Dcl-Pi  *N  End-Pi;
000215141130
000216141130       // Release storage holding state information
000217141130       //   and set pointer to null. That way we can't ever reference
000218141130       //   it by mistake.
000219141130
000220141130       Dealloc info.stateInfo;
000221141130       info.stateInfo = *null;
000222141130       info.rpgStatus = stsOK;
000223141130
000224141130       Return;
000225141130
000226141130       End-Proc CloseFile;
000227141130
